<?php
// $Id: endless_view_style_plugin.inc,v 1.3 2008/11/08 21:01:53 asund Exp $
/**
 * @file
 *  Provide the views carousel plugin object with default options and form.
 */

/**
  * Implementation of views_plugin_style().
  */
class endless_view_style_plugin extends views_plugin_style {


  function render() {
    $rows = '';

    // This will be filled in by the row plugin and is used later on in the
    // theming output.
    $this->namespaces = array();
	
	$i = 0;
    foreach ($this->view->result as $row) {
      $rows[$i] = $row->nid;
      $i++;
    }

    return theme($this->theme_functions(), $this->view, $this->options, $rows);
  }



  function options(&$options) {
    $options['startItems'] = '10';
    $options['groupItems'] = '4';
    $options['scrollMargin'] = '1500';    
    $options['format'] = '0';
  }
 
  /*
   * Provide a form for setting options.
   *
   * @param array $form
   * @param array $form_state
   */ 
  function options_form(&$form, &$form_state) {
    $form['startItems'] = array(
      '#type' => 'textfield',
      '#title' => t('How many items to load when first loading the page'),
      '#size' => 5,
      '#maxlength' => 5,
      '#default_value' => $this->options['startItems'],
    );
    
    $form['groupItems'] = array(
      '#type' => 'textfield',
      '#title' => t('How many items to load each time'),
      '#size' => 5,
      '#maxlength' => 5,
      '#default_value' => $this->options['groupItems'],
    );    

    $form['scrollMargin'] = array(
      '#type' => 'textfield',
      '#title' => t('How far from the bottom of the page should one be before loading more items?'),
      '#size' => 5,
      '#maxlength' => 5,
      '#default_value' => $this->options['scrollMargin'],
      '#field_suffix' => ' pixels',
    );    


    $form['format'] = array(
      '#type' => 'radios',
      '#title' => t('Node format'),
      '#options' => array(0 => t('Full node'), 1 => t('Teaser')),
      '#default_value' => $this->options['format'],
    );
  }

}